﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.85
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim dummy1 As RuntimePermissions
	
	Public SQL1 As SQL
	Private xui As XUI 'ignore
	
	Public SQLDataBasePath As String
	Public SQLDateBaseName As String
	Public SQLTabelName As String


	Public ListIDList As List			' list containing the IDs of the Stock table
	Public ProductIDList As List		' list containing the IDs of the Product table
	Public ShopIDList As List		' list containing the IDs of the Supplier	table
	' we need them because the IDs can be different from the list indexes
	' if we delete an entry its ID is lost
	
	Public SelectedListID As Long
	Public SelectedProductID As Long
	Public SelectedShopID As Long
	
	' we need to know which main button was selected as an operation
	Public SelectedOperation As String
	
	'Variables for Edit
	'the Edit Activities have two modes  "Add"  and "Edit"
	Public ListEditMode As String
	Public ProductEditMode As String
	Public ShopEditMode As String

	'Variables for Filter
	'variable for the filter query,
	'defined in the btnFilter_Click routine of the Filter module
	'and will be used In the DBWebView ShowTable routine
	Public FilterQuery = "" As String
	
	' flag for the filter active or inactive
	Public FilterActive = False As Boolean
	
	' Boolean operator used in the filter
	' can be OR or AND
	Public FilterBooleanOperator = "AND " As String
	
	' Variables used to hold the selected indexes of the Spinners
	Public FilterSelectedProduct As Int
	Public FilterSelectedShop As Int
	Public FilterSelectedDateBegin As Int
	Public FilterSelectedDateEnd As Int
	
	Public GotBarCode As String ' redundant
	Public GotBarScanType As String  ' redundant

	Public HtmlCSS As String
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	
	'initialize the variables
	''''	SQLDataBasePath = File.DirDefaultExternal & "/"     '.DirRootExternal
	''' SQL Data Path -> /storage/emulated/0/Android/data/rabbitBUSH.bonsaiBASE/files/

	''''''''''''''''''''''''''''''''''''''''''''''
	SQLDataBasePath = dummy1.GetSafeDirDefaultExternal ("")
		''''Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)

'''''''''''''''''''''''''''''''''''''''''''''''''''''
	
	SQLDateBaseName = "cards.db"
	
	FilterQuery = ""
	FilterActive = False
	FilterBooleanOperator = "OR "
	
	dummy1.GetAllSafeDirsExternal("rabbitBUSH")
	'check if the database already exists
	
'	File.Delete(SQLDataBasePath, SQLDateBaseName) ' only for testing, removes the database

	''
	If File.Exists(SQLDataBasePath, SQLDateBaseName) = True Then
		'if yes, initialize it
		''
		SQL1.Initialize(SQLDataBasePath, SQLDateBaseName, True)
		''
		ToastMessageShow("CARD file present",False)
		
	'''	xui.MsgboxAsync(SQLDataBasePath, "Located at ... ")
	Else
			ToastMessageShow("CARD file not found: CREATING new database",False)
		''xui.MsgboxAsync("CREATING new database", "BONSAI file not found: ")
	
		'if not EXIST, initialize it create the folder and file as well
		''
' reopen later		
		SQL1.Initialize(SQLDataBasePath, SQLDateBaseName, True)
' *************************************************************************
		'and create it
		''
' reopen later		
		SQLInit
''*************************************************************************
	End If

	HtmlCSS = "table {width: 100%;border: 1px solid #cef;text-align: left; }" _
		& " th { font-weight: bold;	background-color: #acf;	border-bottom: 1px solid #cef; }" _ 
		& "td,th {	padding: 4px 5px; }" _
		& ".odd {background-color: #def; } .odd td {border-bottom: 1px solid #cef; }" _
		& "a { text-decoration:none; color: #000;}"
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

'create the List database
Sub SQLInit
	Private query As String
	
	''query = "CREATE TABLE List (Number INTEGER, ProductID INTEGER, shopID INTEGER, Date INTEGER)"
	' insert one new field for cancel off list because its been purchased
	' add three spare fields just so they are there and can be used in future without regenerating the DB
	
	query = "CREATE TABLE Cards (RecNum INTEGER, CommName TEXT, SciName TEXT, acquired TEXT, colltype INTEGER, indig INTEGER, decidu INTEGER, conifer INTEGER, price FLOAT, location TEXT, age INTEGER,  style INTEGER, wiring DATE, potting DATE, fert DATE, spray DATE, rootprune DATE, canopyprune DATE, soilmix INTEGER)"

	SQL1.ExecNonQuery(query)
	'''	
'	query = "INSERT INTO List VALUES (5, 1, " & DateTime.Now & ")"
'	
	query = "INSERT INTO Cards VALUES ('1', 'Card One', 'First Card', '1-Jan-2024', '1', '0', '0', '0','100.00','Home-1','5','0','1-Jan-2024','1-Jan-2024','1-Jan-2024','1-Jan-2024','1-Jan-2024','1-Jan-2024','0')"
		SQL1.ExecNonQuery(query)
	query = "INSERT INTO Cards VALUES ('2', 'Card Two', 'Second Card', '2-Jan-2024', '1', '0', '0', '0','200.00','Home-2','5','1','2-Jan-2024','2-Jan-2024','2-Jan-2024','2-Jan-2024','2-Jan-2024','2-Jan-2024','1')"
		SQL1.ExecNonQuery(query)
	query = "INSERT INTO Cards VALUES ('3', 'Card Three', 'Third Card', '3-Jan-2024', '1', '0', '0', '0','300.00','Home-3','5','2','3-Jan-2024','3-Jan-2024','3-Jan-2024','3-Jan-2024','3-Jan-2024','3-Jan-2024','2')"
		SQL1.ExecNonQuery(query)
	query = "INSERT INTO Cards VALUES ('4', 'Card Four', 'Fourth Card', '4-Jan-2024', '1', '0', '0', '0','400.00','Home-4','5','3','4-Jan-2024','4-Jan-2024','4-Jan-2024','4-Jan-2024','4-Jan-2024','4-Jan-2024','4')"
		SQL1.ExecNonQuery(query)
	query = "INSERT INTO Cards VALUES ('5', 'Card Five', 'Fifth Card', '5-Jan-2024', '1', '0', '0', '0','100.00','Home-1','5','4','5-Jan-2024','1-Jan-2024','1-Jan-2024','1-Jan-2024','1-Jan-2024','1-Jan-2024','0')"
		SQL1.ExecNonQuery(query)
	query = "INSERT INTO Cards VALUES ('6', 'Card Six', 'Sixth Card', '6-Jan-2024', '1', '0', '0', '0','200.00','Home-2','5','5','2-Jan-2024','2-Jan-2024','2-Jan-2024','2-Jan-2024','2-Jan-2024','2-Jan-2024','1')"
		SQL1.ExecNonQuery(query)
	query = "INSERT INTO Cards VALUES ('7', 'Card Seven', 'Seventh Card', '7-Jan-2024', '1', '0', '0', '0','300.00','Home-3','5','6','3-Jan-2024','3-Jan-2024','3-Jan-2024','3-Jan-2024','3-Jan-2024','3-Jan-2024','2')"
		SQL1.ExecNonQuery(query)
	query = "INSERT INTO Cards VALUES ('8', 'Card Eight', 'Eighth Card', '8-Jan-2024', '1', '0', '0', '0','400.00','Home-4','5','7','4-Jan-2024','4-Jan-2024','4-Jan-2024','4-Jan-2024','4-Jan-2024','4-Jan-2024','3')"
		SQL1.ExecNonQuery(query)
	'''''''''''''''''''''''''''''''
End Sub
